<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmAccounts extends Controller_Handler {
        
        public function before() {
            $this->model = new Model_Admin_Accounts();
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        public function action_getActivationForTeachers()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $departmentsHandled = array(); $i = 0;
            $departments = $this->model->getDepartmentsByFaculty($facultyID);
            foreach ($departments as $department)
            {
                $i++; $j = 0;
                $accounts = DataArray::factory('Teachers')->byDepartment($department['ID'])->asArray();
                if ($accounts == null)
                    continue;
                $departmentsHandled[$i]['Name'] = $department['Name'];
                foreach ($accounts as $row)
                {    
                    //echo Debug::vars($row);
                    $accInfo = $this->model->getAccountInfoByID($row['ID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $departmentsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                        $departmentsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                        $departmentsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                        $departmentsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $departmentsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $this->_sendPDF('activationTeachers'.$facultyID, 
                        'pdf/activationTeacher',
                        array('Departments' => $departmentsHandled, 'System' => array('Title' => ASSEMBLY_SYSTEM_NAME, 'Version' => ASSEMBLY_VERSION)));
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
        
        public function action_getActivationForStudents()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $gradeNum = $this->post->offsetGet('gradeNum');
            $groupsHandled = array(); $i = 0;
            $studyGroups = DataArray::factory('StudyGroups')->ordByGroups($gradeNum, $facultyID)->asArray();
            foreach ($studyGroups as $group)
            {
                $i++; $j = 0;
                $accounts = DataArray::factory('Students')->byStudyGroup($group['ID'])->asArray();
                $groupsHandled[$i]['Grade'] = $gradeNum;
                $groupsHandled[$i]['Num'] = $group['Num'];
                $groupsHandled[$i]['Spec'] = $group['SpecName'];

                foreach ($accounts as $row)
                {
                    echo Debug::vars($row);
                    $accInfo = $this->model->getAccountInfoByID($row['ID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $groupsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                        $groupsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                        $groupsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                        $groupsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $groupsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
            $this->_sendPDF('activationStudents'.$facultyID.'-'.$gradeNum, 
                    'pdf/activationStudent',
                    array('Groups' => $groupsHandled, 'System' => array('Title' => ASSEMBLY_SYSTEM_NAME, 'Version' => ASSEMBLY_VERSION)));
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
        
        protected function _sendPDF($filename, $template, $data)
        {
            $mpdf = View_MPDF::factory($template, $data);
            $cssPath = 'media/css/pdf/activationTemplate.css';
            $css = file_get_contents($cssPath);
            $mpdf->get_mpdf()->WriteHTML($css, 1);
            $this->response->headers('Set-Cookie',  'fileDownload=true; path=/');
            $this->response->headers('Content-Type',  'application/octet-stream');
            $this->response->headers('Accept-Ranges', 'bytes');
            $this->response->headers('Content-Length', strlen($mpdf));
            $this->response->headers('Content-Disposition',  'attachment; filename='.$filename.'.pdf');
            $this->response->headers('Content-Transfer-Encoding',  'Binary');
            $this->response->body($mpdf);
        }
}